﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using I87KCANnet_PAC;
using Wincon;
using DCONCE;

namespace WinPAC_Demo
{
    public partial class Form1 : Form
    {
        int Slot,Ret;
        uint Baud;
        String StrText;
        Byte ComPort = 0, Scroll = 1;
        ulong MsgCnt = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            pan_rx.Enabled = false;
            pan_tx.Enabled = false;
            bt_close.Enabled = false;

            cb_baud.SelectedIndex = 0;
            cb_slot.SelectedIndex = 0;

            tx1_mode.Text = "0";
            tx1_id.Text = "123";
            tx1_rtr.Text = "0";
            tx1_dlen.Text = "8";
            tx1_d0.Text = "11";
            tx1_d1.Text = "22";
            tx1_d2.Text = "33";
            tx1_d3.Text = "44";
            tx1_d4.Text = "55";
            tx1_d5.Text = "66";
            tx1_d6.Text = "77";
            tx1_d7.Text = "88";

            tx2_mode.Text = "0";
            tx2_id.Text = "123";
            tx2_rtr.Text = "0";
            tx2_dlen.Text = "8";
            tx2_d0.Text = "11";
            tx2_d1.Text = "22";
            tx2_d2.Text = "33";
            tx2_d3.Text = "44";
            tx2_d4.Text = "55";
            tx2_d5.Text = "66";
            tx2_d6.Text = "77";
            tx2_d7.Text = "88";
        }

        private void bt_config_Click(object sender, EventArgs e)
        {
            Slot = cb_slot.SelectedIndex;
            switch (cb_baud.SelectedIndex)
            {
                case 0:
                    Baud = 10000U;
                    break;
                case 1:
                    Baud = 20000U;
                    break;
                case 2:
                    Baud = 50000U;
                    break;
                case 3:
                    Baud = 125000U;
                    break;
                case 4:
                    Baud = 250000U;
                    break;
                case 5:
                    Baud = 500000U;
                    break;
                case 6:
                    Baud = 800000U;
                    break;
                case 7:
                    Baud = 1000000U;
                    break;
            };

            DCONCE.Dcon.UART.Open_Com(ComPort, 115200, 8, 0, 0);
            Wincon.Wcon.System.ChangeSlotTo87K((byte)Slot);

            Ret = I87KCANnet_PAC.I87KCAN.I87KCANInit(Baud, 0, 0, 0x00000000, 0xffffffff, 1, 0);
            if (Ret != 0)
            {
                StrText = String.Format("I-87120 Initial Err = {0}", Ret);
                MessageBox.Show(StrText);
                DCONCE.Dcon.UART.Close_Com(ComPort);
            }
            else
            {
                cb_baud.Enabled = false;
                cb_slot.Enabled = false;
                bt_config.Enabled = false;

                pan_rx.Enabled = true;
                pan_tx.Enabled = true;
                bt_close.Enabled = true;
            }
        }

        private void bt_close_Click(object sender, EventArgs e)
        {
            Ret = I87KCANnet_PAC.I87KCAN.ResetI87KCAN();
            if (Ret != 0)
            {
                StrText = String.Format("I-87120 Reset Err = {0}", Ret);
                MessageBox.Show(StrText);
            }
            else
            {
                MsgCnt = 0;
                Scroll = 1;

                cb_baud.Enabled = true;
                cb_slot.Enabled = true;
                bt_config.Enabled = true;

                pan_rx.Enabled = false;
                pan_tx.Enabled = false;
                bt_close.Enabled = false;
                timer1.Enabled = false;

                bt_scroll.Text = "Stop Scroll";
                bt_receive.Text = "Receive";

                DCONCE.Dcon.UART.Close_Com(ComPort);
            }
        }

        private void bt1_send_Click(object sender, EventArgs e)
        {
            Byte Mode, Rtr, Dlen;
            Byte[] Data = new byte[8];
            uint ID;

            Mode = Convert.ToByte(tx1_mode.Text, 16);
            Rtr = Convert.ToByte(tx1_rtr.Text, 16);
            Dlen = Convert.ToByte(tx1_dlen.Text, 16);
            Data[0] = Convert.ToByte(tx1_d0.Text, 16);
            Data[1] = Convert.ToByte(tx1_d1.Text, 16);
            Data[2] = Convert.ToByte(tx1_d2.Text, 16);
            Data[3] = Convert.ToByte(tx1_d3.Text, 16);
            Data[4] = Convert.ToByte(tx1_d4.Text, 16);
            Data[5] = Convert.ToByte(tx1_d5.Text, 16);
            Data[6] = Convert.ToByte(tx1_d6.Text, 16);
            Data[7] = Convert.ToByte(tx1_d7.Text, 16);
            ID = Convert.ToUInt32(tx1_id.Text,16);
            
            I87KCANnet_PAC.I87KCAN.SendCANMsg(Mode, ID, Rtr, Dlen, Data);
        }

        private void bt2_send_Click(object sender, EventArgs e)
        {
            Byte Mode, Rtr, Dlen;
            Byte[] Data = new byte[8];
            uint ID;

            Mode = Convert.ToByte(tx2_mode.Text, 16);
            Rtr = Convert.ToByte(tx2_rtr.Text, 16);
            Dlen = Convert.ToByte(tx2_dlen.Text, 16);
            Data[0] = Convert.ToByte(tx2_d0.Text, 16);
            Data[1] = Convert.ToByte(tx2_d1.Text, 16);
            Data[2] = Convert.ToByte(tx2_d2.Text, 16);
            Data[3] = Convert.ToByte(tx2_d3.Text, 16);
            Data[4] = Convert.ToByte(tx2_d4.Text, 16);
            Data[5] = Convert.ToByte(tx2_d5.Text, 16);
            Data[6] = Convert.ToByte(tx2_d6.Text, 16);
            Data[7] = Convert.ToByte(tx2_d7.Text, 16);
            ID = Convert.ToUInt32(tx2_id.Text,16);

            Ret = I87KCANnet_PAC.I87KCAN.SendCANMsg(Mode, ID, Rtr, Dlen, Data);
            if (Ret != 0)
            {
                StrText = String.Format("I-87120 Send Err = {0}", Ret);
                MessageBox.Show(StrText);
            }
        }

        private void bt_receive_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled == false)
            {
                timer1.Enabled = true;
                bt_receive.Text = "Stop";
            }
            else
            {
                timer1.Enabled = false;
                bt_receive.Text = "Receive";
            }
        }

        private void bt_clear_Click(object sender, EventArgs e)
        {
            list_receive.Items.Clear();
            MsgCnt = 0;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Byte Mode, Rtr, Dlen;
            Byte[] Data = new byte[8];
            uint ID;
            String CANStr;

            Ret = I87KCANnet_PAC.I87KCAN.GetCANMsg(out Mode, out ID, out Rtr, out Dlen, Data);
            if ((Ret != 0) && (Ret != 21) && (Ret != 22))
            {
                CANStr = String.Format("I-87120 Receive Err = {0}", Ret);
                list_receive.Items.Add(CANStr);
            }
            else if (Ret == 0)
            {
                if (MsgCnt == 10000)
                {
                    list_receive.Items.Clear();
                    MsgCnt = 0;
                }
                switch (Dlen)
                {
                    case 0:
                        CANStr = String.Format("{0:d4} Mode:{1} , ID:{2:X} , Rtr:{3} , Dlen:{4} , Data: ... ",
                            MsgCnt, Mode, ID, Rtr, Dlen);
                        break;
                    case 1:
                        CANStr = String.Format("{0:d4} Mode:{1} , ID:{2:X} , Rtr:{3} , Dlen:{4} , Data:{5:X2}",
                            MsgCnt, Mode, ID, Rtr, Dlen, Data[0]);
                        break;
                    case 2:
                        CANStr = String.Format("{0:d4} Mode:{1} , ID:{2:X} , Rtr:{3} , Dlen:{4} , Data:{5:X2},{6:X2},",
                            MsgCnt, Mode, ID, Rtr, Dlen, Data[0], Data[1]);
                        break;
                    case 3:
                        CANStr = String.Format("{0:d4} Mode:{1} , ID:{2:X} , Rtr:{3} , Dlen:{4} , Data:{5:X2},{6:X2},{7:X2},",
                            MsgCnt, Mode, ID, Rtr, Dlen, Data[0], Data[1], Data[2]);
                        break;
                    case 4:
                        CANStr = String.Format("{0:d4} Mode:{1} , ID:{2:X} , Rtr:{3} , Dlen:{4} , Data:{5:X2},{6:X2},{7:X2},{8:X2}",
                            MsgCnt, Mode, ID, Rtr, Dlen, Data[0], Data[1], Data[2], Data[3]);
                        break;
                    case 5:
                        CANStr = String.Format("{0:d4} Mode:{1} , ID:{2:X} , Rtr:{3} , Dlen:{4} , Data:{5:X2},{6:X2},{7:X2},{8:X2},{9:X2}",
                            MsgCnt, Mode, ID, Rtr, Dlen, Data[0], Data[1], Data[2], Data[3], Data[4]);
                        break;
                    case 6:
                        CANStr = String.Format("{0:d4} Mode:{1} , ID:{2:X} , Rtr:{3} , Dlen:{4} , Data:{5:X2},{6:X2},{7:X2},{8:X2},{9:X2},{10:X2}",
                            MsgCnt, Mode, ID, Rtr, Dlen, Data[0], Data[1], Data[2], Data[3], Data[4], Data[5]);
                        break;
                    case 7:
                        CANStr = String.Format("{0:d4} Mode:{1} , ID:{2:X} , Rtr:{3} , Dlen:{4} , Data:{5:X2},{6:X2},{7:X2},{8:X2},{9:X2},{10:X2},{11:X2}",
                            MsgCnt, Mode, ID, Rtr, Dlen, Data[0], Data[1], Data[2], Data[3], Data[4], Data[5], Data[6]);
                        break;
                    case 8:
                        CANStr = String.Format("{0:d4} Mode:{1} , ID:{2:X} , Rtr:{3} , Dlen:{4} , Data:{5:X2},{6:X2},{7:X2},{8:X2},{9:X2},{10:X2},{11:X2},{12:X2}",
                            MsgCnt, Mode, ID, Rtr, Dlen, Data[0], Data[1], Data[2], Data[3], Data[4], Data[5], Data[6], Data[7]);
                        break;
                    default:
                        CANStr = "";
                        break;
                }
                list_receive.Items.Add(CANStr);
                if (Scroll == 1)
                {
                    list_receive.SelectedIndex = Convert.ToInt32(MsgCnt);
                }
                MsgCnt++;
            }
        }

        private void bt_scroll_Click(object sender, EventArgs e)
        {
            if (Scroll == 1)
            {
                Scroll = 0;
                bt_scroll.Text = "Scrolling";
            }
            else
            {
                Scroll = 1;
                bt_scroll.Text = "Stop Scroll";
            }
        }

        private void tx1_mode_TextChanged(object sender, EventArgs e)
        {
            if (Convert.ToByte(tx1_mode.Text,16) > 1) tx1_mode.Text = "1";
        }

        private void tx1_id_TextChanged(object sender, EventArgs e)
        {
            if (Convert.ToUInt32(tx1_id.Text,16) > 0x1fffffff) tx1_id.Text = "1fffffff";
        }

        private void tx1_rtr_TextChanged(object sender, EventArgs e)
        {
            if (Convert.ToByte(tx1_rtr.Text,16) > 1) tx1_rtr.Text = "1";
        }

        private void tx1_dlen_TextChanged(object sender, EventArgs e)
        {
            if (Convert.ToByte(tx1_dlen.Text,16) > 8) tx1_dlen.Text = "8";
        }

        private void tx2_mode_TextChanged(object sender, EventArgs e)
        {
            if (Convert.ToByte(tx2_mode.Text,16) > 1) tx2_mode.Text = "1";
        }

        private void tx2_id_TextChanged(object sender, EventArgs e)
        {
            if (Convert.ToUInt32(tx2_id.Text,16) > 0x1fffffff) tx2_id.Text = "1fffffff";
        }

        private void tx2_rtr_TextChanged(object sender, EventArgs e)
        {
            if (Convert.ToByte(tx2_rtr.Text,16) > 1) tx2_rtr.Text = "1";
        }

        private void tx2_dlen_TextChanged(object sender, EventArgs e)
        {
            if (Convert.ToByte(tx2_dlen.Text,16) > 8) tx2_dlen.Text = "8";
        }
    }
}